﻿package com.ronnieswietek.GUI
{
	/**
	* Note: This file uses the free tweening engine: TweenLite. 
	* I have direct permission from Jack Doyle(Author of TweenLite to
	* distribute TweenLite, TweenFilterLite or TweenMax with any of my 
	* files on flashden). Please download it here if you have to:
	* http://blog.greensock.com/tweenliteas3/
	*
	* Please view help.txt or index.html for information on how to setup this menu
	*/
	
	// Import neccessary class files used in this product slider class
	import gs.TweenLite;
	import gs.easing.Expo;
	import flash.display.MovieClip;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.net.navigateToURL;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.xml.*;
	import flash.external.ExternalInterface;
	import flash.text.TextFieldAutoSize;
	
	public class HTMLMenu extends MovieClip
	{
		
		public var XMLSource:String				= "menu.xml";		// The name of your XML file
		public var rollOverColor				= 0xCCFF00;			// The roll over color of your menu items
		public var rollOutColor					= 0xFFFFFF;			// The roll out color of your menu items
		public var easingFunction				= Expo.easeOut;		// The tweening function used
		public var distanceFromTheTop:Number	= 25;				// This number sets the distance from the top of the page for the sub menu
		public var subtitleXPosition:Number		= 155;				// This is the initial starting position of the subtitle menus. It is reference to the X Position of the titleHolder MovieClip
		public var menuSpacing:Number			= 30;				// The space between each menu item horizontally
		public var submenuSpacing:Number		= 17;				// The space between each submenu vertically
		
		private var lastSubHeight:Number		= 0;
		private var subtitleHolder:MovieClip	= new MovieClip();
		private var xmlData:Array 				= new Array();
		private var xmlLoader:URLLoader;
		private var lastOver:MovieClip;
		private var currentIndex:Number;
		private var subHeight:Number;
		
		public function HTMLMenu()
		{
			
			stage.align 					= StageAlign.TOP_LEFT;			// Align the stage top left
			stage.scaleMode 				= StageScaleMode.NO_SCALE;		// No scaling wanted so set to no scale
			
			stage.addEventListener(Event.MOUSE_LEAVE, menuOut);				// If the mouse leaves the menu call the menuOut function
			stage.addEventListener(Event.RESIZE, onResize);					// If the browser gets resized, resize the background of the menu
			
			xmlLoader 						= new URLLoader();				// Load the XML and onComplete call initMenu
			xmlLoader.load(new URLRequest(XMLSource));
			xmlLoader.addEventListener(Event.COMPLETE, initMenu);
			
			onResize();
			
		}
		
		private function initMenu(e:Event):void
		{
			TweenLite.to(this,0.5,{y:0,ease:easingFunction,delay:0.5});		// This slides the menu in from above your HTML page on load
			
			var xml:XML 					= new XML(xmlLoader.data);
			var xmlList:XMLList 			= new XMLList(xml.item);
			var prevItem:TitleClip;
	
            for (var i:int = 0; i < xmlList.length(); i++)
            {
				var node:XML 				= xmlList[i];
				var type:String				= node.@type;
				var title:String			= node.@title;
				var titleClip:TitleClip		= new TitleClip();
				titleClip.id				= i;
				titleClip.txt.text			= title
				titleClip.txt.autoSize		= TextFieldAutoSize.LEFT;
				titleClip.txt.mouseEnabled 	= false;
				
				if (prevItem)																		//This if block is positioning all menu items evenly even if different widths
				{
					
					titleClip.x 			= prevItem.x + prevItem.width + menuSpacing;
					
				}
				else
				{
					
					titleClip.x 			= 0;
					
				}
				
				titleClip.arrow.x 			= 0 + titleClip.txt.width + 10;
				
				titleClip.hit.width			= titleClip.width;
				
				prevItem 					= titleClip;
				
				titleHolder.addChild(titleClip);			
				
				if (type == "sublink")
				{
					
					titleClip.submenu 		= true;					// If it has a submenu give it a property of true
					
				}
				else
				{
					
					titleClip.urlref		= node.@url;			// If it doesnt have a submenu give it an event listener to just click and remove the arrow representing it has a submenu 
					titleClip.window		= node.@window;
					titleClip.addEventListener(MouseEvent.CLICK, itemClick);
					titleClip.arrow.visible = false;
					
				}
				
				titleClip.buttonMode 		= true;
				titleClip.useHandCursor 	= true;
				
				titleClip.addEventListener(MouseEvent.ROLL_OVER, titleOver);
				
			}
			
			prevItem 						= null;
			
		}
		
		
		// This function hides the menu and sets it back to its initial state when the mouse leaves the stage
		private function menuOut(e:Event):void
		{
			
			TweenLite.to(background,0.5,{height:30,ease:easingFunction,onComplete:endTween});
			
			if (lastOver)
			{
				
				TweenLite.to(lastOver,0.5,{tint:rollOutColor,rotation:0,ease:easingFunction});
				
			}
			
			currentIndex = -1;

			removeChildren();
			
		}
		
		
		private function endTween():void
		{
			
			if (ExternalInterface.available)
			{
				
				ExternalInterface.call("closeMenu");
				
			}
			
		}
		
		//This will handle all of the roll over events for the main menu items (not submenu)
		private function titleOver(e:Event):void
		{
			
			if(e.currentTarget.submenu)
			{
				
				if (lastOver)
				{
					
					TweenLite.to(lastOver,0.5,{tint:rollOutColor,rotation:0,ease:easingFunction});
					
				}
				
				lastOver = e.currentTarget.arrow;
				
				if (currentIndex != e.currentTarget.id)
				{
					
					showSub(e.currentTarget.id,e.currentTarget.x);
					currentIndex = e.currentTarget.id;
					
				}
				
				TweenLite.to(e.currentTarget.arrow,0.5,{tint:rollOverColor,rotation:90,ease:easingFunction});
				
			}
			else
			{
				if (lastOver)
				{
					
					TweenLite.to(lastOver,0.5,{tint:rollOutColor,rotation:0,ease:easingFunction});
					
				}
				
				lastOver = e.currentTarget.arrow;
				
				lastSubHeight = 0;
				
				if (currentIndex != e.currentTarget.id)
				{
					
					currentIndex = e.currentTarget.id;
					
				}
				
				TweenLite.to(e.currentTarget.arrow,0.5,{tint:rollOutColor,rotation:90,ease:easingFunction});

				removeChildren();
				TweenLite.to(background,0.5,{height:30,ease:easingFunction,onComplete:endTween});
				
			}

		}
		
		// If it has a submenu run this function which will create sub menus below the current menu item your on
		private function showSub(itemID:Number,xPosition:Number):void
		{
			
			removeChildren();
			
			var xml:XML 					= new XML(xmlLoader.data);
			var node:XML 					= xml.item[itemID] as XML;
			subtitleHolder					= new MovieClip();
			subtitleHolder.x 				= xPosition + subtitleXPosition;
			subtitleHolder.y 				= distanceFromTheTop;
			subHeight 						= 30;
			
			addChild(subtitleHolder);

			for (var i:int = 0; i < node.subitem.length(); i++)
			{
				
				var subtitle:String 		= node.subitem[i].@title;
				var url:String 				= node.subitem[i].@url;
				var window:String 			= node.subitem[i].@window;
				var submenu:SubClip			= new SubClip();
				
				submenu.txt.text			= subtitle;
				submenu.txt.mouseEnabled 	= false;
				submenu.txt.autoSize 		= TextFieldAutoSize.LEFT;
				
				submenu.alpha				= 0;
				submenu.y 					= i * submenuSpacing;	//This is where you can adjust the height bewtween each sub menu.
				submenu.buttonMode 			= true;
				submenu.useHandCursor 		= true;
				
				submenu.urlref				= url;
				submenu.window				= window;
				
				submenu.subBG.width			= submenu.width;
				submenu.subBG.alpha			= 0;
				submenu.subBG.mouseEnabled	= false;
				
				subHeight 					+= submenuSpacing;
				
				submenu.addEventListener(MouseEvent.CLICK, itemClick);
				submenu.addEventListener(MouseEvent.ROLL_OVER, subOver);
				submenu.addEventListener(MouseEvent.ROLL_OUT, subOut);
				
				subtitleHolder.addChild(submenu);
				
				TweenLite.to(submenu,0.5,{alpha:1,ease:easingFunction,delay: i * 0.04});
				
			}
			
			if (lastSubHeight <= subHeight)
			{
				
				TweenLite.to(background,0.5,{height: subHeight,ease:easingFunction});
				setDivHeight(subHeight);
				lastSubHeight = subHeight;
				
			}
			else
			{
				
				TweenLite.to(background,0.5,{height: subHeight,ease:easingFunction,onCompleteParams:[subHeight],onComplete:setDivHeight});
				lastSubHeight = subHeight;
				
			}

		}
		
		// This sets the height of the DIV in the HTML to aquire the new size of the menu
		private function setDivHeight(val):void
		{
			
			if (ExternalInterface.available)
			{
				
				ExternalInterface.call("openMenu",val);
				
			}
			
		}
				
		// This launches a url when a submenu or a menu with no subs is clicked.
		private function itemClick(e:MouseEvent):void
		{
			
			navigateToURL(new URLRequest(e.currentTarget.urlref),e.currentTarget.window);
			
		}
		
		// This functions handles the roll over events for submenu items
		private function subOver(e:MouseEvent):void
		{
			
			TweenLite.to(e.currentTarget.subBG,0.5,{alpha:1,ease:easingFunction});
			TweenLite.to(e.currentTarget.txt,0.5,{tint:rollOverColor,ease:easingFunction});
			
		}
		
		// This functions handles the roll out events for submenu items
		private function subOut(e:MouseEvent):void
		{
			
			TweenLite.to(e.currentTarget.subBG,0.5,{alpha:0,ease:easingFunction,delay:0.06});
			TweenLite.to(e.currentTarget.txt,0.5,{tint:rollOutColor,ease:easingFunction});
			
		}
		
		// When you roll onto another menu item or the mouse leaves the stage, this gets called and removes them
		private function removeChildren():void
		{
			
			var children:Number 			= subtitleHolder.numChildren;
			var count:Number 				= 0;
			
			while(children--)
			{
				
				count++;
				var ref 					= subtitleHolder.getChildAt(children);
				TweenLite.to(ref,0.3,{autoAlpha:0,ease:easingFunction,delay:count * 0.03});
				
			}
			
		}
		
		
		// If the browser gets resizeed, resize the background of the menu to the height of the browser
		private function onResize(e:Event = null):void
		{
			
			background.width 				= stage.stageWidth;
			
		}
		
	}
	
}